-- Localized Functions for the European Version
-- Outsorced functions:
-- _GFind

if ( GetLocale() == "deDE" or GetLocale() == "enGB" or GetLocale() == "enUS" or GetLocale() == "frFR") then

	if ( GetLocale() == "frFR" ) then

		function CEnemyCastBar_Gfind_Debuffs(arg1, event) --Gfind_Debuffs

			-- return if Spell damage from other players/mobs is detected -> german client problem (without it DoTs from everyone will be displayed, see next clause)
			if (string.find(arg1, CEnemyCastBar_SPELL_DAMAGE) ) then

				return;
			end


			for spell, damage, mob in string.gmatch(arg1, CEnemyCastBar_SPELL_DAMAGE_SELFOTHER) do

					CEnemyCastBar_Control(mob, spell, "periodicdmg");
				return;
			end

			-- periodic debuff damage routine for frFR, enUS and deDE pattern, No.2 - crit! has to be checked first!
			for spell, mob, damage in string.gmatch(arg1, CEnemyCastBar_SPELL_CRITS_SELFOTHER) do

					CEnemyCastBar_Control(mob, spell, "periodichitdmg");
				return;
			end

			-- periodic debuff damage routine for frFR, enUS and deDE pattern, No.3 - noncrit! has to be checked after crit!
			for spell, mob, damage in string.gmatch(arg1, CEnemyCastBar_SPELL_HITS_SELFOTHER) do

					CEnemyCastBar_Control(mob, spell, "periodichitdmg");
				return;
			end

			for mob, crap, spell in string.gmatch(arg1, CEnemyCastBar_SPELL_AFFLICTED) do

				NECB_interrupt_casting(spell, mob); -- spell interrupting idea from Lazarus
				CEnemyCastBar_Control(mob, spell, "afflicted", nil, event);
				return;
			end

			for mob, spell in string.gmatch(arg1, CEnemyCastBar_SPELL_REMOVED) do

				CEnemyCastBar_Control(mob, spell, "fades");
				return;
			end

			if (CEnemyCastBar.bSpellBreaks) then
				for mob, spell in string.gmatch(arg1, CEnemyCastBar_SPELL_INTERRUPTED) do

					NECB_interrupt_casting(" ", mob);
					return;
				end

				for interrupter, mob, spell in string.gmatch(arg1, CEnemyCastBar_SPELL_INTERRUPTED_OTHER) do
						
					NECB_interrupt_casting(" ", mob);
					return;
				end
			end

		end

	elseif ( GetLocale() == "deDE" ) then

		function CEnemyCastBar_Gfind_Debuffs(arg1, event) --Gfind_Debuffs

			-- return if Spell damage from other players/mobs is detected -> german client problem (without it DoTs from everyone will be displayed, see next clause)
			if (string.find(arg1, CEnemyCastBar_SPELL_DAMAGE) ) then

				return;
			end

			-- periodic debuff damage routine for enUS and deDE pattern, No.1
			for mob, damage, spell in string.gmatch(arg1, CEnemyCastBar_SPELL_DAMAGE_SELFOTHER) do

					CEnemyCastBar_Control(mob, spell, "periodicdmg");
				return;
			end

			-- periodic debuff damage routine for frFR, enUS and deDE pattern, No.2 - crit! has to be checked first!
			for spell, mob, damage in string.gmatch(arg1, CEnemyCastBar_SPELL_CRITS_SELFOTHER) do

					CEnemyCastBar_Control(mob, spell, "periodichitdmg");
				return;
			end

			-- periodic debuff damage routine for frFR, enUS and deDE pattern, No.3 - noncrit! has to be checked after crit!
			for spell, mob, damage in string.gmatch(arg1, CEnemyCastBar_SPELL_HITS_SELFOTHER) do

					CEnemyCastBar_Control(mob, spell, "periodichitdmg");
				return;
			end

			for mob, spell in string.gmatch(arg1, CEnemyCastBar_SPELL_AFFLICTED) do

				NECB_interrupt_casting(spell, mob); -- spell interrupting idea from Lazarus
				CEnemyCastBar_Control(mob, spell, "afflicted", nil, event);
				return;
			end

			for mob, spell in string.gmatch(arg1, CEnemyCastBar_SPELL_AFFLICTED2) do

				NECB_interrupt_casting(spell, mob); -- spell interrupting idea from Lazarus
				CEnemyCastBar_Control(mob, spell, "afflicted", nil, event);
				return;
			end

			for spell, mob in string.gmatch(arg1, CEnemyCastBar_SPELL_REMOVED) do

				CEnemyCastBar_Control(mob, spell, "fades");
				return;
			end

			if (CEnemyCastBar.bSpellBreaks) then
				-- event == "CHAT_MSG_SPELL_SELF_DAMAGE"
				for spell, mob in string.gmatch(arg1, CEnemyCastBar_SPELL_INTERRUPTED) do

					NECB_interrupt_casting(" ", mob);
					return;
				end

				-- event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE"
				for interrupter, spell, mob in string.gmatch(arg1, CEnemyCastBar_SPELL_INTERRUPTED_OTHER) do

					NECB_interrupt_casting(" ", mob);
					return;
				end
			end

		end

	else

		function CEnemyCastBar_Gfind_Debuffs(arg1, event) --Gfind_Debuffs

			-- return if Spell damage from other players/mobs is detected -> german client problem (without it DoTs from everyone will be displayed, see next clause)
			if (string.find(arg1, CEnemyCastBar_SPELL_DAMAGE) ) then

				return;
			end

			-- periodic debuff damage routine for enUS and deDE pattern, No.1
			for mob, damage, spell in string.gmatch(arg1, CEnemyCastBar_SPELL_DAMAGE_SELFOTHER) do

					CEnemyCastBar_Control(mob, spell, "periodicdmg");
				return;
			end

			-- periodic debuff damage routine for frFR, enUS and deDE pattern, No.2 - crit! has to be checked first!
			for spell, mob, damage in string.gmatch(arg1, CEnemyCastBar_SPELL_CRITS_SELFOTHER) do

					CEnemyCastBar_Control(mob, spell, "periodichitdmg");
				return;
			end

			-- periodic debuff damage routine for frFR, enUS and deDE pattern, No.3 - noncrit! has to be checked after crit!
			for spell, mob, damage in string.gmatch(arg1, CEnemyCastBar_SPELL_HITS_SELFOTHER) do

					CEnemyCastBar_Control(mob, spell, "periodichitdmg");
				return;
			end

			for mob, crap, spell in string.gmatch(arg1, CEnemyCastBar_SPELL_AFFLICTED) do

				NECB_interrupt_casting(spell, mob); -- spell interrupting idea from Lazarus
				CEnemyCastBar_Control(mob, spell, "afflicted", nil, event);
				return;
			end

			for mob, spell in string.gmatch(arg1, CEnemyCastBar_SPELL_REMOVED) do

				CEnemyCastBar_Control(mob, spell, "fades");
				return;
			end

			if (CEnemyCastBar.bSpellBreaks) then
				for mob, spell in string.gmatch(arg1, CEnemyCastBar_SPELL_INTERRUPTED) do

					NECB_interrupt_casting(" ", mob);
					return;
				end

				for interrupter, mob, spell in string.gmatch(arg1, CEnemyCastBar_SPELL_INTERRUPTED_OTHER) do
						
					NECB_interrupt_casting(" ", mob);
					return;
				end
			end

		end

	end

end